package Java10.Detyra1;

import java.util.*;

public class EkipiOlimpik {
    private String emri;
    private ArrayList<Sportisti> sportistet;
    private Iterator<Sportisti> iterator;

    public EkipiOlimpik(String e) throws SportistiException{
        if(e == null || e.trim().isEmpty()){
            throw new SportistiException("Emri i ekipit jovalid!");
        }
        emri = e;
        sportistet = new ArrayList<Sportisti>();
    }

    public void shtoSportistin(Sportisti s) throws SportistiException{
        if(s == null){
            throw new SportistiException("Sportisti i painicializuar!");
        }
        else if(sportistet.contains(s)){
            throw new SportistiException(s + " vetem se ekziston!");
        }
        else{
            sportistet.add(s);
        }
    }

    public void shtypDistancen(double d) throws SportistiException{
        if(sportistet.isEmpty()){
            throw new SportistiException("Lista e zbrazet!");
        }

        if(d < 0){
            throw new SportistiException("Distanca jovalide - shtypDistancen!");
        }

        iterator = sportistet.iterator();

        while(iterator.hasNext()){
            Sportisti s = iterator.next();
            if(s instanceof Vrapuesi){
                if(((Vrapuesi)s).getDistanca() == d){
                    System.out.println(s);
                }
            }
        }
    }

    public void shtypEmrin() throws SportistiException{
        if(sportistet.isEmpty()){
            throw new SportistiException("Lista e zbrazet!");
        }

        iterator = sportistet.iterator();

        while(iterator.hasNext()){
            Sportisti s = iterator.next();
            if(s.getEmri().startsWith("A")){
                System.out.println(s);
            }
        }
 
    }

    public ArrayList<Sportisti> ktheIndividualet(boolean ind) throws SportistiException{
        if(sportistet.isEmpty()){
            throw new SportistiException("Lista e zbrazet!");
        }

        ArrayList<Sportisti> spInd = new ArrayList<Sportisti>();
        iterator = sportistet.iterator();

        while(iterator.hasNext()){
            Sportisti s = iterator.next();
            if(s.garonIndividualisht()==ind){
                spInd.add(s);
            }

        }
        return spInd;
    }

    public void fshijSportistin() throws SportistiException{
        if(sportistet.isEmpty()){
            throw new SportistiException("Lista e zbrazet!");
        }

        sportistet.removeIf(s -> (s.getMosha() == 30));
    }

    public void print(){
        iterator = sportistet.iterator();
        while(iterator.hasNext()){
            Sportisti s = (Sportisti)iterator.next();
            System.out.println(s);
        }
    }

    public static void main(String [] args){
        EkipiOlimpik eo = null;

        try{
            eo = new EkipiOlimpik("Kosova Team");

            Sportisti s1 = new Futbollisti(1234, "A1", (byte)20, 'M', (byte)20);
            Sportisti s2 = new Karateisti(1235, "K1", (byte)30, 'M', "taekwondo");
            Sportisti s3 = new Vrapuesi(1236, "A2", (byte)19, 'F', (byte)30, 400);
            Sportisti s4 = new Vrapuesi(1237, "V2", (byte)10, 'F', (byte)5, 500);
            Sportisti s5 = new Vrapuesi(1238, "V3", (byte)30, 'M', (byte)20, 400);

            eo.shtoSportistin(s1);
            eo.shtoSportistin(s2);
            eo.shtoSportistin(s3);
            eo.shtoSportistin(s4);
            eo.shtoSportistin(s5);
            eo.print();
        }catch(SportistiException se){
            se.printStackTrace();
        }

        try{
            System.out.println("==============Lista e vrapuesve me distancen 400 m: ");
            eo.shtypDistancen(400);
        }catch(SportistiException se){
            se.printStackTrace();
        }

        try{
            System.out.println("==============Lista e sportisteve, te cileve iu fillon emri me A: ");
            eo.shtypEmrin();
        }catch(SportistiException se){
            se.printStackTrace();
        }

        try{
            System.out.println("==============Lista e sportisteve individuale: ");
            System.out.println(eo.ktheIndividualet(true));
        }catch(SportistiException se){
            se.printStackTrace();
        }

        try{
            System.out.println("==============Lista e sportisteve pas fshirjes: ");
            eo.fshijSportistin();
            eo.print();
        }catch(SportistiException se){
            se.printStackTrace();
        }
    }


}
